#include <stdio.h>
#include <mpi.h>
#include <unistd.h>

int main(int argc,char *argv[]){
  int rank, size;
  int value, sum;

  MPI_Init(&argc, &argv);

  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  printf("Hello world from process %d of %d\n", rank, size);

  if (rank == 0)
    value = 1;
  else if (rank == 1)
    value = 4;
  else
    value = 3;

  MPI_Allreduce(&value,&sum,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
  if (rank == 0)
    printf("The sum is %d\n",sum);

  MPI_Finalize();

  return 0;
}

